/*******************************************************************************
 * Size: 32 px
 * Bpp: 1
 * Opts: 
 ******************************************************************************/

#ifdef LV_LVGL_H_INCLUDE_SIMPLE
#include "lvgl.h"
#else
#include "lvgl/lvgl.h"
#endif

#ifndef MATERIAL_WEBFONT_32
#define MATERIAL_WEBFONT_32 1
#endif

#if MATERIAL_WEBFONT_32

/*-----------------
 *    BITMAPS
 *----------------*/

/*Store the image of the glyphs*/
static LV_ATTRIBUTE_LARGE_CONST const uint8_t glyph_bitmap[] = {
    /* U+F007A "󰁺" */
    0xf, 0xf0, 0xf, 0xf0, 0xf, 0xf0, 0x7f, 0xfe,
    0xff, 0xff, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7,
    0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7,
    0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7,
    0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7,
    0xe0, 0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x7f, 0xfe,

    /* U+F0504 "󰔄" */
    0x3c, 0x0, 0x0, 0x7e, 0x0, 0x0, 0xe7, 0x1,
    0xf8, 0xe7, 0x7, 0xfc, 0xe7, 0x1f, 0xfe, 0xe7,
    0x3f, 0xfe, 0x7e, 0x3f, 0xfe, 0x3c, 0x7f, 0x4,
    0x0, 0x7c, 0x0, 0x0, 0xf8, 0x0, 0x0, 0xf8,
    0x0, 0x0, 0xf0, 0x0, 0x0, 0xf0, 0x0, 0x0,
    0xf0, 0x0, 0x0, 0xf0, 0x0, 0x0, 0xf8, 0x0,
    0x0, 0x78, 0x0, 0x0, 0x7c, 0x0, 0x0, 0x3f,
    0xc, 0x0, 0x1f, 0xfc, 0x0, 0xf, 0xfe, 0x0,
    0x7, 0xfe, 0x0, 0x1, 0xf8,

    /* U+F058C "󰖌" */
    0x0, 0x0, 0x1, 0x80, 0x3, 0xc0, 0x7, 0xe0,
    0x7, 0xe0, 0xf, 0xf0, 0x1f, 0xf8, 0x1f, 0xf8,
    0x3f, 0xfc, 0x3f, 0xfc, 0x7f, 0xfe, 0x7f, 0xfe,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x7f, 0xfe, 0x7f, 0xfe, 0x3f, 0xfc,
    0x1f, 0xf8, 0xf, 0xf0, 0x1, 0x80,

    /* U+F0599 "󰖙" */
    0x0, 0x0, 0x0, 0x0, 0x18, 0x0, 0x0, 0x18,
    0x0, 0x0, 0x3c, 0x0, 0x0, 0x66, 0x0, 0x0,
    0x0, 0x0, 0x0, 0x0, 0x0, 0xf8, 0x7e, 0x1f,
    0x71, 0xff, 0x8e, 0x63, 0xc3, 0xc6, 0x23, 0x81,
    0xc4, 0x7, 0x0, 0xe0, 0x7, 0x0, 0xe0, 0x7,
    0x0, 0xe0, 0x7, 0x0, 0xe0, 0x23, 0x81, 0xc4,
    0x23, 0xc3, 0xc4, 0x71, 0xff, 0x8e, 0xf8, 0x7e,
    0x1f, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0x66, 0x0, 0x0, 0x3c, 0x0, 0x0, 0x18, 0x0,
    0x0, 0x18, 0x0, 0x0, 0x0, 0x0,

    /* U+F05AD "󰖭" */
    0xe0, 0x0, 0xfe, 0x0, 0x3d, 0xe0, 0xf, 0x1e,
    0x3, 0xc1, 0xe0, 0xf0, 0x1e, 0x3c, 0x1, 0xef,
    0x0, 0x1f, 0xc0, 0x1, 0xf0, 0x0, 0x3e, 0x0,
    0xf, 0xe0, 0x3, 0xde, 0x0, 0xf1, 0xe0, 0x3c,
    0x1e, 0xf, 0x1, 0xe3, 0xc0, 0x1e, 0xf0, 0x1,
    0xfc, 0x0, 0x1c,

    /* U+F0928 "󰤨" */
    0x0, 0x1f, 0xf8, 0x0, 0x1, 0xff, 0xff, 0x80,
    0x7, 0xff, 0xff, 0xe0, 0x1f, 0xff, 0xff, 0xf8,
    0x3f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xfe,
    0x7f, 0xff, 0xff, 0xfe, 0x3f, 0xff, 0xff, 0xfc,
    0x1f, 0xff, 0xff, 0xf8, 0xf, 0xff, 0xff, 0xf0,
    0x7, 0xff, 0xff, 0xe0, 0x7, 0xff, 0xff, 0xe0,
    0x3, 0xff, 0xff, 0xc0, 0x1, 0xff, 0xff, 0x80,
    0x0, 0xff, 0xff, 0x0, 0x0, 0x7f, 0xfe, 0x0,
    0x0, 0x7f, 0xfe, 0x0, 0x0, 0x3f, 0xfc, 0x0,
    0x0, 0x1f, 0xf8, 0x0, 0x0, 0xf, 0xf0, 0x0,
    0x0, 0x7, 0xe0, 0x0, 0x0, 0x7, 0xe0, 0x0,
    0x0, 0x3, 0xc0, 0x0, 0x0, 0x1, 0x80, 0x0,
    0x0, 0x0, 0x0, 0x0,

    /* U+F092D "󰤭" */
    0x8, 0x0, 0x0, 0x0, 0x1c, 0x0, 0x0, 0x0,
    0xe, 0x1f, 0xf8, 0x0, 0x7, 0x1f, 0xff, 0x80,
    0x7, 0x8f, 0xff, 0xe0, 0x1f, 0xc7, 0xff, 0xf8,
    0x3f, 0xe3, 0xff, 0xfc, 0x7f, 0xf1, 0xff, 0xfe,
    0x7f, 0xf8, 0xff, 0xfe, 0x3f, 0xfc, 0x7f, 0xfc,
    0x1f, 0xfe, 0x3f, 0xf8, 0xf, 0xff, 0x1f, 0xf0,
    0x7, 0xff, 0x8f, 0xe0, 0x7, 0xff, 0xc7, 0xe0,
    0x3, 0xff, 0xe3, 0xc0, 0x1, 0xff, 0xf1, 0x80,
    0x0, 0xff, 0xf8, 0x0, 0x0, 0x7f, 0xfc, 0x0,
    0x0, 0x7f, 0xfe, 0x0, 0x0, 0x3f, 0xff, 0x0,
    0x0, 0x1f, 0xff, 0x80, 0x0, 0xf, 0xf3, 0xc0,
    0x0, 0x7, 0xe1, 0xe0, 0x0, 0x7, 0xe0, 0xe0,
    0x0, 0x3, 0xc0, 0x40, 0x0, 0x1, 0x80, 0x0,
    0x0, 0x0, 0x0, 0x0
};


/*---------------------
 *  GLYPH DESCRIPTION
 *--------------------*/

static const lv_font_fmt_txt_glyph_dsc_t glyph_dsc[] = {
    {.bitmap_index = 0, .adv_w = 0, .box_w = 0, .box_h = 0, .ofs_x = 0, .ofs_y = 0} /* id = 0 reserved */,
    {.bitmap_index = 0, .adv_w = 512, .box_w = 16, .box_h = 26, .ofs_x = 8, .ofs_y = -1},
    {.bitmap_index = 52, .adv_w = 512, .box_w = 24, .box_h = 23, .ofs_x = 4, .ofs_y = 1},
    {.bitmap_index = 121, .adv_w = 512, .box_w = 16, .box_h = 23, .ofs_x = 8, .ofs_y = 1},
    {.bitmap_index = 167, .adv_w = 512, .box_w = 24, .box_h = 26, .ofs_x = 4, .ofs_y = -1},
    {.bitmap_index = 245, .adv_w = 512, .box_w = 19, .box_h = 18, .ofs_x = 6, .ofs_y = 3},
    {.bitmap_index = 288, .adv_w = 512, .box_w = 32, .box_h = 25, .ofs_x = 0, .ofs_y = -1},
    {.bitmap_index = 388, .adv_w = 512, .box_w = 32, .box_h = 27, .ofs_x = 0, .ofs_y = -1}
};

/*---------------------
 *  CHARACTER MAPPING
 *--------------------*/

static const uint16_t unicode_list_0[] = {
    0x0, 0x48a, 0x512, 0x51f, 0x533, 0x8ae, 0x8b3
};

/*Collect the unicode lists and glyph_id offsets*/
static const lv_font_fmt_txt_cmap_t cmaps[] =
{
    {
        .range_start = 983162, .range_length = 2228, .glyph_id_start = 1,
        .unicode_list = unicode_list_0, .glyph_id_ofs_list = NULL, .list_length = 7, .type = LV_FONT_FMT_TXT_CMAP_SPARSE_TINY
    }
};



/*--------------------
 *  ALL CUSTOM DATA
 *--------------------*/

#if LV_VERSION_CHECK(8, 0, 0)
/*Store all the custom data of the font*/
static  lv_font_fmt_txt_glyph_cache_t cache;
static const lv_font_fmt_txt_dsc_t font_dsc = {
#else
static lv_font_fmt_txt_dsc_t font_dsc = {
#endif
    .glyph_bitmap = glyph_bitmap,
    .glyph_dsc = glyph_dsc,
    .cmaps = cmaps,
    .kern_dsc = NULL,
    .kern_scale = 0,
    .cmap_num = 1,
    .bpp = 1,
    .kern_classes = 0,
    .bitmap_format = 0,
#if LV_VERSION_CHECK(8, 0, 0)
    .cache = &cache
#endif
};


/*-----------------
 *  PUBLIC FONT
 *----------------*/

/*Initialize a public general font descriptor*/
#if LV_VERSION_CHECK(8, 0, 0)
const lv_font_t material_webfont_32 = {
#else
lv_font_t material_webfont_32 = {
#endif
    .get_glyph_dsc = lv_font_get_glyph_dsc_fmt_txt,    /*Function pointer to get glyph's data*/
    .get_glyph_bitmap = lv_font_get_bitmap_fmt_txt,    /*Function pointer to get glyph's bitmap*/
    .line_height = 27,          /*The maximum line height required by the font*/
    .base_line = 1,             /*Baseline measured from the bottom of the line*/
#if !(LVGL_VERSION_MAJOR == 6 && LVGL_VERSION_MINOR == 0)
    .subpx = LV_FONT_SUBPX_NONE,
#endif
#if LV_VERSION_CHECK(7, 4, 0) || LVGL_VERSION_MAJOR >= 8
    .underline_position = 0,
    .underline_thickness = 0,
#endif
    .dsc = &font_dsc           /*The custom font data. Will be accessed by `get_glyph_bitmap/dsc` */
};



#endif /*#if MATERIAL_WEBFONT_32*/

